unit SHA1Win;

interface

uses SHA1Ur;

type
{$ALIGN 4}
  TSHA1Res = TSHA1Digest;
  TSHA1 = Packed Record
    Procedure Init; StdCall;
    Procedure Update (Input: Pointer; inLen: LongWord); StdCall;
    Procedure Finalize(Result: TSHA1Res); StdCall;
    Function doFinalize: TSHA1Res; Inline;

    Class Function Calc (Input: Pointer; inLen: LongWord): TSHA1Res; Static;
  Public
    Unknown: Array[0.. 5] of LongWord;
    State: Array[0.. 4] of LongWord;
    Count: UInt64;
    Buffer: Array[0..63] of Byte;
  End;
  {$ALIGN 8}

implementation

Procedure TSHA1.Init{Var Context: SHA_CTX}; StdCall;
  External 'advapi32.dll' Name 'A_SHAInit';

Procedure TSHA1.Update{Var Context: SHA_CTX; Input: Pointer; inLen: LongWord}; StdCall;
  External 'advapi32.dll' Name 'A_SHAUpdate';

Procedure TSHA1.Finalize{Var Context: SHA_CTX; Out Result: SHA_RES}; StdCall;
  External 'advapi32.dll' Name 'A_SHAFinal';

Function TSHA1.doFinalize: TSHA1Res;
  Begin
    Finalize(Result);
  End;

Class Function TSHA1.Calc(Input: Pointer; inLen: LongWord): TSHA1Res;
  Var X: TSHA1;

  Begin
    X.Init;
    X.Update(Input, inLen);
    X.Finalize(Result);
  End;


end.
