unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, sha1ur, StdCtrls, Sha1Win, Sha1Teilasm, Math, SyncObjs, DateUtils,
  ExtCtrls;

type
  TMillionHashes = class(TThread)
    private
      procedure ShowResult;
      var
        Result: string;
    protected
      procedure Execute(); override;
  end;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    CheckBox1: TCheckBox;
    ScrollBar1: TScrollBar;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox4: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    Edit9: TEdit;
    Label10: TLabel;
    Edit10: TEdit;
    Label11: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  PublicKey: AnsiString;
  InitialSHA1: TSHA1;
  Iteration: Integer;
  IterationMax: Integer;
  ShouldTerminate: Boolean;
  EndThreads: Boolean;
  IterationMutex: TMutex;
  And2, And3, And4: Byte;
  Start: TDateTime;
  CountMutex: TMutex;
  ThreadCount: Integer;

type
  PByte = ^Byte;

implementation

{$R *.dfm}

function ShowDigest(const Digest: TSHA1Digest): string;
var
  i,j,k: Integer;
begin
  Result := '';
  for i := 0 to 19 do
  Result := Result + IntToHex(Digest[i],2);

  k := 0;
  for i := 0 to 19 do
  for j := 0 to 7 do
  if (Digest[i] shr j) and 1 = 0 then
  inc(k)
  else
  begin
    Result := 'Stufe ' + IntToStr(k) + ' (' + Result + ')';
    Exit;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  sha1: array[0..7] of SHA1Ur.TSHA1Context;
  Key: AnsiString;
  Digest: SHA1Ur.TSHA1Digest;
  P0, P1, P2, P3, P4, P5, P6: Byte;
begin
  SHA1Ur.SHA1Init(sha1[0]);
  Key := AnsiString(Edit1.Text);
  SHA1Ur.sha1update(sha1[0], Key[1], Length(Key));
  //ShowMessage(ShowDigest(sha1final(sha1[0])));

  for P0 := 49 to 57 do
  begin
    sha1[1] := sha1[0];
    SHA1Ur.SHA1Update(sha1[1], P0, 1);
    for P1 := 48 to 57 do
    begin
      sha1[2] := sha1[1];
      SHA1Ur.SHA1Update(sha1[2], P1, 1);
      for P2 := 48 to 57 do
      begin
        sha1[3] := sha1[2];
        SHA1Ur.SHA1Update(sha1[3], P2, 1);
        for P3 := 48 to 57 do
        begin
          sha1[4] := sha1[3];
          SHA1Ur.SHA1Update(sha1[4], P3, 1);
          for P4 := 48 to 57 do
          begin
            sha1[5] := sha1[4];
            SHA1Ur.SHA1Update(sha1[5], P4, 1);
            for P5 := 48 to 57 do
            begin
              sha1[6] := sha1[5];
              SHA1Ur.SHA1Update(sha1[6], P5, 1);
              for P6 := 48 to 57 do
              begin
                sha1[7] := sha1[6];
                SHA1Ur.SHA1Update(sha1[7], P6, 1);
                Digest := SHA1Ur.SHA1Final(sha1[7]);
                if Digest[0] = 0 then
                if Digest[1] = 0 then
                if Digest[2] and And2 = 0 then
                if Digest[3] and And3 = 0 then
                if Digest[4] and And4 = 0 then
                begin
                  Memo1.Lines.Add(string(AnsiChar(P0) + AnsiChar(P1) + AnsiChar(P2) + AnsiChar(P3) + AnsiChar(P4) + AnsiChar(P5) + AnsiChar(P6)) + ' ' + ShowDigest(Digest));
                  if Checkbox1.Checked then
                  Exit;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  sha1: array[0..7] of TSHA1;
  Key: AnsiString;
  Digest: TSHA1Digest;
  P0, P1, P2, P3, P4, P5, P6: Byte;
begin
  SHA1[0].Init;
  Key := AnsiString(Edit1.Text);
  SHA1[0].Update(@Key[1], Length(Key));
  //ShowMessage(ShowDigest(sha1final(sha1[0])));

  for P0 := 48 to 57 do
  begin
    sha1[1] := sha1[0];
    if P0 > 48 then
    sha1[1].Update(@P0, 1);
    for P1 := 48 to 57 do
    begin
      sha1[2] := sha1[1];
      sha1[2].Update(@P1, 1);
      for P2 := 48 to 57 do
      begin
        sha1[3] := sha1[2];
        sha1[3].Update(@P2, 1);
        for P3 := 48 to 57 do
        begin
          sha1[4] := sha1[3];
          sha1[4].Update(@P3, 1);
          for P4 := 48 to 57 do
          begin
            sha1[5] := sha1[4];
            sha1[5].Update(@P4, 1);
            for P5 := 48 to 57 do
            begin
              sha1[6] := sha1[5];
              sha1[6].Update(@P5, 1);
              for P6 := 48 to 57 do
              begin
                sha1[7] := sha1[6];
                sha1[7].Update(@P6, 1);
                sha1[7].Finalize(Digest);
                if Digest[0] = 0 then
                if Digest[1] = 0 then
                if Digest[2] and And2 = 0 then
                if Digest[3] and And3 = 0 then
                if Digest[4] and And4 = 0 then
                begin
                  Memo1.Lines.Add(string(AnsiChar(P0) + AnsiChar(P1) + AnsiChar(P2) + AnsiChar(P3) + AnsiChar(P4) + AnsiChar(P5) + AnsiChar(P6)) + ' ' + ShowDigest(Digest));
                  if Checkbox1.Checked then
                  Exit;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  sha1: array[0..7] of SHA1TeilAsm.TSHA1Context;
  Key: AnsiString;
  Digest: TSHA1Digest;
  P0, P1, P2, P3, P4, P5, P6: Byte;
begin
  SHA1TeilAsm.SHA1Init(sha1[0]);
  Key := AnsiString(Edit1.Text);
  SHA1TeilAsm.sha1update(sha1[0], @Key[1], Length(Key));
  //ShowMessage(ShowDigest(sha1final(sha1[0])));

  for P0 := 49 to 57 do
  begin
    sha1[1] := sha1[0];
    SHA1TeilAsm.SHA1Update(sha1[1], @P0, 1);
    for P1 := 48 to 57 do
    begin
      sha1[2] := sha1[1];
      SHA1TeilAsm.SHA1Update(sha1[2], @P1, 1);
      for P2 := 48 to 57 do
      begin
        sha1[3] := sha1[2];
        SHA1TeilAsm.SHA1Update(sha1[3], @P2, 1);
        for P3 := 48 to 57 do
        begin
          sha1[4] := sha1[3];
          SHA1TeilAsm.SHA1Update(sha1[4], @P3, 1);
          for P4 := 48 to 57 do
          begin
            sha1[5] := sha1[4];
            SHA1TeilAsm.SHA1Update(sha1[5], @P4, 1);
            for P5 := 48 to 57 do
            begin
              sha1[6] := sha1[5];
              SHA1TeilAsm.SHA1Update(sha1[6], @P5, 1);
              for P6 := 48 to 57 do
              begin
                sha1[7] := sha1[6];
                SHA1TeilAsm.SHA1Update(sha1[7], @P6, 1);
                SHA1TeilAsm.SHA1Final(sha1[7], Digest);
                if Digest[0] = 0 then
                if Digest[1] = 0 then
                if Digest[2] and And2 = 0 then
                if Digest[3] and And3 = 0 then
                if Digest[4] and And4 = 0 then
                begin
                  Memo1.Lines.Add(string(AnsiChar(P0) + AnsiChar(P1) + AnsiChar(P2) + AnsiChar(P3) + AnsiChar(P4) + AnsiChar(P5) + AnsiChar(P6)) + ' ' + ShowDigest(Digest));
                  if Checkbox1.Checked then
                  Exit;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  TempThread: TMillionHashes;
  i: Integer;
begin
  InitialSHA1.Init;
  PublicKey := AnsiString(Edit1.Text);
  InitialSHA1.Update(@PublicKey[1], Length(PublicKey));
  Iteration := StrToInt(Edit9.Text);
  IterationMax := StrToInt(Edit10.Text);
  EndThreads := False;
  Start := Now;
  ThreadCount := StrToInt(Edit8.Text);
  for i := 1 to StrToInt(Edit8.Text) do
  TempThread := TMillionHashes.Create(False);
  Timer1.Enabled := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  EndThreads := True;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  ShouldTerminate := Checkbox1.Checked;
end;

procedure TForm1.Edit1Change(Sender: TObject);
const
  Base64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' +
           'abcdefghijklmnopqrstuvwxyz' +
           '0123456789+/';
function AvatarFilenameToUID(const Filename: string): string;
var
  // UIDs are 160 bits long, the additional 2 bits are just for easier decoding
  Temp: array[0..161] of Byte;
  i: Byte;
begin
  Temp[160] := 0;
  Temp[161] := 0;
  for i := 0 to 39 do
  begin
    Temp[i*4  ] := (Ord(Filename[i+1])-97)       div 8;
    Temp[i*4+1] := (Ord(Filename[i+1])-97) mod 8 div 4;
    Temp[i*4+2] := (Ord(Filename[i+1])-97) mod 4 div 2;
    Temp[i*4+3] := (Ord(Filename[i+1])-97) mod 2;
  end;
  Result := '';
  for i := 0 to 26 do
  Result := Result + Base64[Temp[i*6] * 32 + Temp[i*6+1] * 16 + Temp[i*6+2] * 8 + Temp[i*6+3] * 4 + Temp[i*6+4] * 2 + Temp[i*6+5] + 1];
  Result := Result + '=';
end;
function ShowDigest(const Digest: TSHA1Digest): string;
const
  Hex = 'abcdefghijklmnop';
var
  i: Integer;
begin
  Result := '';
  for i := 0 to 19 do
  Result := Result + Hex[Digest[i] shr 4 and $f + 1] + Hex[Digest[i] and $f + 1];
end;
var
  sha1: TSHA1;
  Key: AnsiString;
  Digest: TSHA1Digest;
begin
  if StringReplace(Edit1.Text, '\', '', [rfReplaceAll]) <> Edit1.Text then
  Edit1.Text := StringReplace(Edit1.Text, '\', '', [rfReplaceAll]);
  SHA1.Init;
  Key := AnsiString(Edit1.Text);
  SHA1.Update(@Key[1], Length(Key));
  SHA1.Finalize(Digest);
  //Edit2.Text := Base64Encode(RawbyteString(PAnsiChar(@Digest[0])));
  Edit3.Text := 'avatar_' + ShowDigest(Digest);
  Edit2.Text := AvatarFilenameToUID(ShowDigest(Digest));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1Change(nil);
  ScrollBar1Change(nil);
  IterationMutex := TMutex.Create();
  CountMutex := TMutex.Create();
  Shouldterminate := True;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  try
    Edit4.Text := IntToStr(ScrollBar1.Position);
    And2 := Round(IntPower(2, EnsureRange(Scrollbar1.Position-16,0,8)) - 1);
    And3 := Round(IntPower(2, EnsureRange(Scrollbar1.Position-24,0,8)) - 1);
    And4 := Round(IntPower(2, EnsureRange(Scrollbar1.Position-32,0,8)) - 1);
    Edit5.Text := IntToStr(And2);
    Edit6.Text := IntToStr(And3);
    Edit7.Text := IntToStr(And4);
  except
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if ThreadCount = 0 then
  begin
    Timer1.Enabled := False;
    Memo1.Lines.Add(InttoStr(MilliSecondsBetween(Now, Start)) + 'ms: Alle Threads wurden beendet.');
  end;
end;

{ TMillionHashes }

procedure TMillionHashes.Execute;
var
  OwnIteration: Integer;
  sha1: array[1..7] of TSHA1;
  Key: AnsiString;
  Digest: TSHA1Digest;
  P1, P2, P3, P4, P5, P6: Byte;
begin
  inherited;
  FreeOnTerminate := True;
  try
    while not Terminated and not EndThreads do
      begin
      IterationMutex.Acquire;
      try
        if Iteration >= IterationMax then Exit;
        OwnIteration := Iteration;
        Inc(Iteration);
      finally
        IterationMutex.Release;
      end;

      Key := AnsiString(IntToStr(OwnIteration));
      sha1[1] := InitialSHA1;
      sha1[1].Update(@Key[1], Length(Key));

      for P1 := 48 to 57 do
      begin
        sha1[2] := sha1[1];
        sha1[2].Update(@P1, 1);
        for P2 := 48 to 57 do
        begin
          sha1[3] := sha1[2];
          sha1[3].Update(@P2, 1);
          for P3 := 48 to 57 do
          begin
            sha1[4] := sha1[3];
            sha1[4].Update(@P3, 1);
            for P4 := 48 to 57 do
            begin
              sha1[5] := sha1[4];
              sha1[5].Update(@P4, 1);
              for P5 := 48 to 57 do
              begin
                sha1[6] := sha1[5];
                sha1[6].Update(@P5, 1);
                for P6 := 48 to 57 do
                begin
                  sha1[7] := sha1[6];
                  sha1[7].Update(@P6, 1);
                  sha1[7].Finalize(Digest);
                  if Digest[0] = 0 then
                  if Digest[1] = 0 then
                  if Digest[2] and And2 = 0 then
                  if Digest[3] and And3 = 0 then
                  if Digest[4] and And4 = 0 then
                  begin
                    Result := IntToStr(MilliSecondsBetween(Now, Start)) + 'ms: ' + IntToStr(OwnIteration) + string(AnsiChar(P1) + AnsiChar(P2) + AnsiChar(P3) + AnsiChar(P4) + AnsiChar(P5) + AnsiChar(P6)) + ' ' + ShowDigest(Digest);
                    Synchronize(ShowResult);
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  finally
    Terminate;
    CountMutex.Acquire;
    Dec(ThreadCount);
    CountMutex.Release;
  end;
end;

procedure TMillionHashes.ShowResult;
begin
  Form1.Memo1.Lines.Add(Result);
  if ShouldTerminate then
  EndThreads := True;
end;

end.
